SystemOrganization addCategory: #SnippetsOfLauritzThamsen!

Object subclass: #SqueakSourceToGitMigrator
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SnippetsOfLauritzThamsen'!

!SqueakSourceToGitMigrator methodsFor: 'as yet unclassified' stamp: 'lt 1/13/2013 12:25:30.383'!
gitCommitPackage: fileTreeSubFolder inRepository: gitRepositoryPath withMessage: commitMessage

	OSProcess thisOSProcess 
		chDir: gitRepositoryPath;
		waitForCommand: 'git add ', fileTreeSubFolder;
		waitForCommand:  'git commit -am "', commitMessage, '"'.! !

!SqueakSourceToGitMigrator methodsFor: 'as yet unclassified' stamp: 'lt 1/13/2013 12:25:49.388'!
migratePackage: packageName fromSqueakSourceRepository: squeakSourceRepositoryLocation toGitRepository: gitRepositoryPath inFolder: fileTreeSubFolder
	"examples:
		squeakSourceRepositoryLocation := 'http://www.hpi.uni-potsdam.de/hirschfeld/squeaksource/modsystraits02'. 
		packageName := 'TraitClasses'.
		gitRepositoryPath := '/Users/lauritz/Code/Repositories/TraitClasses/'.
		fileTreeSubFolder := 'packages/'."
	| package squeakSourceRepository fileTreeRepositoryPath fileTreeRepository versionNames |
	fileTreeRepositoryPath := gitRepositoryPath, fileTreeSubFolder.
	package := MCPackage named: packageName.
	squeakSourceRepository := self repositoryForPackage: package atLocation: squeakSourceRepositoryLocation.
	fileTreeRepository := MCFileTreeRepository directory: (FileDirectory forFileName: fileTreeRepositoryPath).
	
	versionNames := squeakSourceRepository versionNamesForPackageNamed: packageName.
	versionNames reverse do: [:each || version |
		version := squeakSourceRepository versionNamed: each.
		fileTreeRepository storeVersion: version.
		self 
			gitCommitPackage: fileTreeSubFolder 
			inRepository: gitRepositoryPath 
			withMessage: version info name, ': ', version info message. ].! !

!SqueakSourceToGitMigrator methodsFor: 'as yet unclassified' stamp: 'lt 1/13/2013 12:20:30.142'!
repositoryForPackage: package atLocation: squeakSourceRepositoryLocation

	| repositoryGroup |
	repositoryGroup := package workingCopy repositoryGroup.
	
	(repositoryGroup repositories size < 2) 
		ifTrue:  [self error: 'package ', package,' not loaded'].

	^ repositoryGroup repositories 
	detect: [ :each | 
		each class == MCHttpRepository 
			and: [each locationWithTrailingSlash includesSubString: squeakSourceRepositoryLocation ]]
	ifNone: [ self error: 'no repository at ', squeakSourceRepositoryLocation ].! !
